void __pushHeap(std::vector<int>& heap, int cur, int top, int val)
{
	int parent = (cur - 1) / 2;
	while (cur > top && heap[parent] < val)
	{
		heap[cur] = heap[parent];
		cur = parent;
		parent = (cur - 1) / 2;
	}
	heap[cur] = val;
}

void pushHeap(std::vector<int>& heap, int val)
{
	heap.push_back(val);
	__pushHeap(heap, heap.end()-heap.begin()-1, 0, val);
}

void __adjustHeap(std::vector<int>& heap, int cur, int n, int val)
{
	int top = cur, right = 2*cur + 2;
	while (right < n)
	{
		if (heap[right-1] > heap[right])
			--right;
		heap[cur] = heap[right];
		cur = right;
		right = 2*right + 2;
	}
	if (right == n)
	{
		heap[cur] = heap[right-1];
		cur = right - 1;
	}
	__pushHeap(heap, cur, top, val);
}

void __popHeap(std::vector<int>& heap, int last)
{
	int lastVal = heap[last];
	heap[last] = heap[0];
	__adjustHeap(heap, 0, last, lastVal);
}

void popHeap(std::vector<int>& heap)
{
	int last = heap.end() - heap.begin() - 1;
	if (last > 0)
		__popHeap(heap, last);
	heap.pop_back();
}

void makeHeap(std::vector<int>& heap)
{
	int n = heap.end() - heap.begin(), parent = (n - 2) / 2 + 1;
	if (n < 2)
		return;
	while (--parent >= 0)
		__adjustHeap(heap, parent, n, heap[parent]);
}

void sortHeap(std::vector<int>& heap)
{
	int last = heap.end() - heap.begin();
	while (--last > 0)
		__popHeap(heap, last);
}
