#include <iostream>
#include <cstdlib>
#include <cstring>
#include <vector>

//////////////////////////////    Array    //////////////////////////////
void merge(std::vector<int>& A, int lo, int mid, int hi)
{
	std::vector<int> T(A.begin()+lo, A.begin()+mid+1);
	int i = 0, j = mid + 1, k = lo;
	while (j <= hi)
		A[k++] = i <= mid - lo && T[i] <= A[j] ? T[i++] : A[j++];
	while (i <= mid - lo)
		A[k++] = T[i++];
}

void mergeSort(std::vector<int>& A, int lo, int hi)
{
	if (lo < hi)
	{
		int mid = lo + (hi - lo >> 1);
		mergeSort(A, lo, mid);
		mergeSort(A, mid+1, hi);
		merge(A, lo, mid, hi);
	}
}

/** non-recursive edition. */
void mergeSorting(std::vector<int>& A)
{
	int n = static_cast<int>(A.size());
	for (int L = 2; L < n << 1; L <<= 1)
	{
		for (int lo = 0, mid = lo + L/2 - 1; mid < n - 1; lo += L, mid = lo + L/2 - 1)
		{
			int hi = lo + L - 1;
			if (hi >= n)
				hi = n - 1;
			merge(A, lo, mid, hi);
		}
	}
}

void mergeSorting(std::vector<int>& A)
{
	mergeSort(A, 0, A.size()-1);
}

//////////////////////////////    List    //////////////////////////////
ListNode* mergeTwoLists(ListNode *l1, ListNode *l2)
{
	ListNode preHead(0), *tail = &preHead;
	while (l1 != NULL && l2 != NULL)
	{
		tail = tail->next = l1->val < l2->val ? l1 : l2;
		if (l1->val < l2->val)
			l1 = l1->next;
		else
			l2 = l2->next;
	}
	tail->next = l1 != NULL ? l1 : l2;
	return preHead.next;
}

ListNode* sortList(ListNode *head)
{
	if (head == NULL || head->next == NULL)
		return head;
	ListNode *slow = head, *fast = head->next->next;
	while (fast != NULL && fast->next != NULL)
	{
		fast = fast->next->next;
		slow = slow->next;
	}
	fast = slow->next;
	slow->next = NULL;
	slow = sortList(head);
	fast = sortList(fast);
	return mergeTwoLists(slow, fast);
}
