#include <iostream>
#include <cstdlib>
#include <cstring>
#include <vector>

//////////////////////////////    Array    //////////////////////////////
void insertionSort(std::vector<int>& A)
{
	int n = static_cast<int>(A.size());
	for (int i = 1, j = 0; i < n; ++i)
	{
		int num = A[i];
		for (j = i; j > 0 && A[j-1] > num; --j)
			A[j] = A[j-1];
		A[j] = num;
	}
}

void bubbleSort(std::vector<int>& A)
{
	int n = static_cast<int>(A.size());
	for (int i = 0; i < n-1; ++i)
	{
		bool finish = true;
		for (int j = 0; j < n-i-1; ++j)
		{
			if (A[j] > A[j+1])
			{
				std::swap(A[j], A[j+1]);
				finish = false;
			}
		}
		if (finish)
			break;
	}
}

void selectionSort(std::vector<int>& A)
{
	int n = static_cast<int>(A.size());
	for (int i = 0; i < n-1; ++i)
	{
		int minJ = i, min = A[i];
		for (int j = i+1; j < n; ++j)
		{
			if (min > A[j])
			{
				min = A[j];
				minJ = j;
			}
		}
		std::swap(A[i], A[minJ]);
	}
}

//////////////////////////////    List    //////////////////////////////
ListNode* insertionSortList(ListNode *head)
{
	if (head == NULL || head->next == NULL)
		return head;
	ListNode preHead(0);
	preHead.next = head;
	ListNode *p = NULL, *q = head; // q is the tail of ordered sequence
	while (q->next != NULL)
	{
		p = &preHead;
		while (p->next != q && p->next->val < q->next->val)
			p = p->next;
		// insert to tail means no need to insert
		if (p->next == q && q->val <= q->next->val)
			q = q->next;
		// 0 -> 3 -> 6 -> 8 -> 1 -> 2    or    0 -> 3 -> 6 -> 8 -> 7 -> 2
		// p              q    r         or              p    q    r
		else // insert q->next between p and p->next
		{
			ListNode *r = q->next;
			q->next = r->next;
			r->next = p->next;
			p->next = r;
		}
	}
	return preHead.next;
}

ListNode* bubbleSortList(ListNode *head)
{
	if (head == NULL || head->next == NULL)
		return head;
	ListNode preHead(0);
	preHead.next = head;
	// tail->prev is the tail of unordered sequence
	ListNode *p = &preHead, *q = p->next, *tail = NULL;
	for (; q->next != tail; p = &preHead, q = p->next)
	{
		bool finish = true;
		while (q->next != tail)
		{
			if (p->next->val > q->next->val)
			{
				ListNode *r = q->next;
				q->next = r->next;
				r->next = q;
				p->next = r;
				finish = false;
			}
			else
				q = q->next;
			p = p->next;
		}
		tail = q;
		if (finish)
			break;
	}
	return preHead.next;
}

ListNode* selectionSortList(ListNode *head)
{
	if (head == NULL || head->next == NULL)
		return head;
	ListNode preHead(0);
	// p is the tail of ordered sequence, q is the head of unordered sequence
	ListNode *p = &preHead, *q = head;
	while (q != NULL)
	{
		ListNode *preMin = NULL, *min = q;
		for (ListNode *r = q; r->next != NULL; r = r->next)
		{
			if (min->val > r->next->val)
			{
				preMin = r;
				min = r->next;
			}
		}
		if (min != q)
			preMin->next = min->next;
		else
			q = q->next;
		p = p->next = min;
	}
	return preHead.next;
}
